# EA Standard Template Library 

EASTL stands for Electronic Arts Standard Template Library. It is a C++ template library of containers, algorithms, and iterators useful for runtime and tool development across multiple platforms. It is a fairly extensive and robust implementation of such a library and has an emphasis on high performance above all other considerations.


## Usage

If you are familiar with the C++ STL or have worked with other templated container/algorithm libraries, you probably don't need to read this. If you have no familiarity with C++ templates at all, then you probably will need more than this document to get you up to speed. In this case you need to understand that templates, when used properly, are powerful vehicles for the ease of creation of optimized C++ code. A description of C++ templates is outside the scope of this documentation, but there is plenty of such documentation on the Interent. 

EASTL is suitable in any tools and shipping applications where the functionality of EASTL is useful. Modern compilers are capable of producing good code with templates and many people are using them in both current generation and future generation applications on multiple platforms from embedded systems to servers and mainframes.


## Credits

EASTL was created by Paul Pedriana and he maintained the project for roughly 10 years.  

Roberto Parolin is the current EASTL owner within EA and is responsible for the open source repository.

Significant EASTL contributions were made by (in alphabetical order):

* Avery Lee
* Colin Andrews
* JP Flouret
* Matt Newport
* Paul Pedriana
* Roberto Parolin
* Simon Everett


## License

Modified BSD Licence (3-Clause BSD license) see the file LICENCE in the project root.
